﻿define([
// dojo
    "dojo",
    "dojo/_base/kernel",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/_base/Deferred",
// epi
    "epi",
    "epi/dependency",
    "epi-cms/widget/_ItemSelectorBase",
    "epi-cms/widget/_DropDownWidgetItemMixin",
// resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.visitorgroupselector"],
function (
// dojo
    dojo,
    kernel,
    lang,
    array,
    Deferred,
// epi
    epi,
    dependency,
    _ItemSelectorBase,
    _DropDownWidgetItemMixin,
// resources
    res) {

    kernel.deprecated("epi-cms/widget/VisitorGroupsSelector is deprecated", "", "9");

    return dojo.declare([_ItemSelectorBase, _DropDownWidgetItemMixin], {
        // tags:
        //      internal

        // defaultItem: [public] Object
        //    The widget's default item to be added to the menu.
        defaultItem: {
            id: -1,
            name: res.defaultitem
        },

        // _visitorGroupsHash: [private] Object
        //    Map the group GUID with its name
        _visitorGroupsHash: {},

        // _isFinished: [private] dojo.Deferred
        //    Deferred to indicate when widget finished its setup process.
        _isFinished: null,

        postMixInProperties: function () {
            // summary:
            //    Sets up the data store
            //
            // tags:
            //    protected
            this.inherited(arguments);
            var registry = dependency.resolve("epi.storeregistry");
            this._store = registry.get("epi.cms.visitorgroup");
        },

        postCreate: function () {
            // summary:
            //    Raised after the widget creating, sets the header and
            //    load the items to be added to the menu.
            //
            // tags:
            //    protected
            this._isFinished = new Deferred();
            this.inherited(arguments);
            this.set("header", res.header);
            dojo.when(this._store.query(), lang.hitch(this, function (visitorGroups) {
                this._createHashMap(visitorGroups);
                this.checkedItem = (this.checkedItem ? this._visitorGroupsHash[this.checkedItem] : this.defaultItem.name);
                visitorGroups.unshift(this.defaultItem);
                this.set("items", visitorGroups);
                this._isFinished.resolve({ status: true });
            }));
        },

        isSetupFinished: function () {
            // summary:
            //    Return a deferred indicating when the widget finished
            //    its setup process.
            //
            // tags:
            //    public
            return this._isFinished;
        },

        _createHashMap: function (items) {
            // summary:
            //    Creates a map with the visitor group GUID and its name
            array.forEach(items, lang.hitch(this, function (item) {
                this._visitorGroupsHash[item.id] = item.name;
            }));
        }
    });
});